#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util.inc>
#include <engine>

#define PLUGIN "Amx Adrenaline"
#define VERSION "0.1.7"
#define AUTHOR "PomanoB"

#define ADMIN_LEVEL ADMIN_KICK

#define SOUND_ON

#if defined SOUND_ON

#define SOUND_ADRENALINE "adrenaline/adrenalin.wav"
#define SOUND_REG "adrenaline/Booster.wav"
#define SOUND_INV "adrenaline/Invisible.wav"
#define SOUND_GODMODE "adrenaline/Berzerk.wav"

#endif

new g_Menu	

new g_cvarSound
new g_cvar_ut_style
new g_cvar_add
new g_cvar_hed

new g_cvar_point_inv,g_cvar_point_reg,g_cvar_point_god

new g_add
new g_hed

new bool:g_Inv[33]
new bool:g_GodMode[33]
new bool:g_AdrenalineIsOn[33]

new g_adrenaline[33]

new g_key[33][4]
new g_time[33]

#if defined SOUND_ON

public plugin_precache()
{
	precache_sound(SOUND_ADRENALINE)
	precache_sound(SOUND_REG)
	precache_sound(SOUND_INV)
	precache_sound(SOUND_GODMODE)
	
}

#endif

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	#if defined SOUND_ON
	g_cvarSound=register_cvar("amx_adrenaline_sound","1")
	#endif	
	g_cvar_ut_style=register_cvar("amx_adrenaline_ut_style","0")
	g_cvar_add=register_cvar("amx_adrenaline_value_add","10")
	g_cvar_hed=register_cvar("amx_adrenaline_hed_add","10")
	g_cvar_point_inv=register_cvar("amx_adrenaline_point_invisible","5")
	g_cvar_point_reg=register_cvar("amx_adrenaline_point_regeneration","5")
	g_cvar_point_god=register_cvar("amx_adrenaline_point_godmodee","10")
	
	register_event("DeathMsg", "onDeath", "a") 
	register_event("ResetHUD", "resetHud", "b")
	register_message(get_user_msgid("TextMsg"), "reset_adrenaline")
	register_concmd("amx_give_adrenaline","cmd_adrenaline",ADMIN_LEVEL," <target> - give adrenaline ") 
	g_Menu = menu_create("Adrenaline Full!","menu_adrenaline");
	build_menu();
}
public plugin_cfg()
{
	g_add=get_pcvar_num(g_cvar_add);
	g_hed=get_pcvar_num(g_cvar_hed);
	
	
}
public client_PreThink(id)
{
	if (!get_pcvar_num(g_cvar_ut_style))
		return PLUGIN_CONTINUE
		
	if (!is_user_alive(id))
		return PLUGIN_CONTINUE
		
	if (g_AdrenalineIsOn[id])
		return PLUGIN_CONTINUE
		
	if (g_adrenaline[id]!=100)
		return PLUGIN_CONTINUE
		
	new button=get_user_button(id)
	if (button==0)
		return PLUGIN_CONTINUE
		
	new oldbutton=get_user_oldbutton(id)
	
	
	if ((button & IN_BACK) && !(oldbutton & IN_BACK))
	{
		add_button(id,'s')
	}
	else if ((button & IN_MOVELEFT) && !(oldbutton & IN_MOVELEFT))
	{
		add_button(id,'a')
	}
	else if ((button & IN_MOVERIGHT) && !(oldbutton & IN_MOVERIGHT))
	{
		add_button(id,'d')
	}
	else
		return PLUGIN_CONTINUE
	
	
		
	new time_out=get_systime()
	if ( (!g_time[id]) || (time_out-g_time[id] >1 ))
	{
		g_time[id]=time_out
		reset_button(id)
		return PLUGIN_CONTINUE;
	}
	g_time[id]=time_out
	
	
	
	
	if (equali(g_key[id],"ssss"))
	{
		g_AdrenalineIsOn[id]=true
		give_Reg(id)
		fm_set_user_rendering(id,kRenderFxGlowShell,255,255,0,kRenderNormal,25) 
		info_print(id,"Your health regenerating!")
		#if defined SOUND_ON
		if (get_pcvar_num(g_cvarSound))
			client_cmd(id, "spk %s",SOUND_REG)
		#endif
	}
	if (equali(g_key[id],"ssww"))
	{
		g_AdrenalineIsOn[id]=true
		give_GodMode(id)
	}
	if (equali(g_key[id],"aadd"))
	{
		g_AdrenalineIsOn[id]=true
		give_Invisible(id)
	}
 
	return PLUGIN_CONTINUE;
}

public add_button(id,button)
{
	new i
	for (i=2;i>=0;i--)
	{
		g_key[id][i+1]=g_key[id][i]
	}
	g_key[id][0]=button
}

public reset_button(id)
{
	new i
	for (i=0;i<4;i++)
	{
		g_key[id][i]=0;
	}
}

build_menu()
{
	menu_additem(g_Menu, "Regeneration", "2");
	menu_additem(g_Menu, "Invisible", "3");
	menu_additem(g_Menu, "GodMode", "4");
	menu_additem(g_Menu, "Exit", "5");
 	menu_setprop(g_Menu, MPROP_PERPAGE, 0);
}


public reset_adrenaline(msgid, dest, id)
{
	if (get_msg_args() != 4 || get_msg_argtype(2) != ARG_STRING)
		return PLUGIN_CONTINUE
	static arg[32]
	get_msg_arg_string(2, arg, sizeof arg - 1)
	
	if (!equal(arg, "#Game_will_restart_in_console"))
		return PLUGIN_CONTINUE
	new i
	
	for (i=1;i<=32;i++)
	{
		remove_task(i)
		g_Inv[i]=false
		g_GodMode[i]=false
		g_AdrenalineIsOn[i]=false
		g_adrenaline[i]=0
		show_adrenaline(32+i)
		
	}
	
	return PLUGIN_CONTINUE
}


public show_adrenaline(id)
{
	
	
	if (is_user_alive(id-32))
	{
		set_hudmessage(255, 255, 0, 0.02, 0.7, 0, 6.0, 10000.0, 0.0, 0.0, 4)
		show_hudmessage(id-32, "Adrenaline: %d", g_adrenaline[id-32])
		
	}
	
	
	return PLUGIN_CONTINUE
}



public onDeath(id) 
{ 
	 
	new iKiller = read_data(1) 
	new iVictim = read_data(2) 
	new iHeadShot = read_data(3) 
	new sWeapon[255]; read_data(4, sWeapon, sizeof(sWeapon)-1) 
	
	remove_task(iVictim)
	g_AdrenalineIsOn[iVictim]=false
	
	if (g_GodMode[iVictim])
	{
		fm_set_user_godmode(iVictim)
	}
	g_Inv[iVictim]=false
	g_GodMode[iVictim]=false
	
	set_task(0.1,"show_adrenaline",32+iKiller)
	
	
	if(iKiller == iVictim && equal(sWeapon, "world", 5) || !iKiller && equal(sWeapon, "world", 5) || !iKiller && equal(sWeapon, "trigger_hurt", 12) ) 
	{
		if (g_adrenaline[iKiller]<10)
		{
			g_adrenaline[iKiller]=0
			return PLUGIN_CONTINUE 
		}
		g_adrenaline[iKiller]-=10
		return PLUGIN_CONTINUE 
	}
	new add_value
	
	if (iHeadShot)
	{
		add_value=g_add+g_hed
	}
	else
		add_value=g_add
	
	if (g_adrenaline[iKiller]+add_value<100)
	{
		g_adrenaline[iKiller]+=add_value
	}
	else
	{
		g_adrenaline[iKiller]=100
		if (!is_user_bot(iKiller) && !g_AdrenalineIsOn[iKiller])
			set_task(1.0,"adrenaline",iKiller)
	}
	return PLUGIN_CONTINUE 
} 

public menu_adrenaline(id, menu, item)
{
	if( item < 0 ) return PLUGIN_CONTINUE;
 
	// Get item info
	new cmd[3];
	new access, callback;
 
	menu_item_getinfo(menu, item, access, cmd,2,_,_, callback);
	g_AdrenalineIsOn[id]=true
	new iChoice = str_to_num(cmd);
	switch(iChoice)
	{
		case 2:{
			give_Reg(id)
			fm_set_user_rendering(id,kRenderFxGlowShell,255,255,0,kRenderNormal,25) 
			info_print(id,"Your health regenerating!")
			#if defined SOUND_ON
			if (get_pcvar_num(g_cvarSound))
				client_cmd(id, "spk %s",SOUND_REG)
			#endif
		}
		case 3:give_Invisible(id)
		case 4:give_GodMode(id)
		case 5:g_AdrenalineIsOn[id]=false
	}
	
 
	return PLUGIN_HANDLED;
}


public give_Reg(id)
{
	if (g_adrenaline[id]>0)
	{
		new user_health = get_user_health(id)
		if (user_health<=250)
		{
			fm_set_user_health(id,user_health + 5)
		}
		else
		{
			fm_set_user_health(id,255)
		}
		if (g_adrenaline[id]-get_pcvar_num(g_cvar_point_reg)>0)
			g_adrenaline[id]-=get_pcvar_num(g_cvar_point_reg)
		else
			g_adrenaline[id]=0;
		set_task(1.0,"give_Reg",id)
	}
	else
	{
		remove_task(id)
		fm_set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,25)
		g_AdrenalineIsOn[id]=false
		info_print(id,"Adrenaline ended!")
	}
	show_adrenaline(32+id)
	
}

public give_Invisible(id)
{
	
	if (!g_Inv[id])
	{
		g_Inv[id]=true
		set_task(1.0,"give_Invisible",id)
		fm_set_user_rendering(id,kRenderFxNone,255,255,255,kRenderTransAdd,60)
		info_print(id,"Your is now invisible!")
		#if defined SOUND_ON
		if (get_pcvar_num(g_cvarSound))
			client_cmd(id, "spk %s",SOUND_INV)
		#endif
	}
	else
	{
		if (g_adrenaline[id]>0)
		{
			if (g_adrenaline[id]-get_pcvar_num(g_cvar_point_inv)>0)
				g_adrenaline[id]-=get_pcvar_num(g_cvar_point_inv)
			else
				g_adrenaline[id]=0;
			set_task(1.0,"give_Invisible",id)
		}
		else
		{
			fm_set_user_rendering(id,kRenderFxNone,255,255,255, kRenderNormal,16)
			g_Inv[id]=false
			g_AdrenalineIsOn[id]=false
			info_print(id,"Adrenaline ended!")
		}
	}
	show_adrenaline(32+id)
	
	
}



public give_GodMode(id)
{
	if (g_adrenaline[id]>0)
	{
		if (!g_GodMode[id])
		{
			fm_set_user_godmode(id, 1)
			g_GodMode[id]=true
			info_print(id,"GodMode is now enabled!!")
			fm_set_user_rendering(id,kRenderFxGlowShell,255,0,255,kRenderNormal,25) 
			#if defined SOUND_ON
			if (get_pcvar_num(g_cvarSound))
				client_cmd(id, "spk %s",SOUND_GODMODE)
			#endif
		}
		if (g_adrenaline[id]-get_pcvar_num(g_cvar_point_god)>0)
			g_adrenaline[id]-=get_pcvar_num(g_cvar_point_god)
		else
			g_adrenaline[id]=0;
		
		set_task(1.0,"give_GodMode",id)
	}
	else
	{
		remove_task(id)
		fm_set_user_godmode(id)
		g_AdrenalineIsOn[id]=false
		g_GodMode[id]=false
		fm_set_user_rendering(id,kRenderFxNone,255,255,255, kRenderNormal,16)
		info_print(id,"Adrenaline ended!")
	}
	show_adrenaline(32+id)
	
	
}


public adrenaline(id)
{
	remove_task(id)
	g_Inv[id]=false
	g_GodMode[id]=false
	g_AdrenalineIsOn[id]=false
	if (is_user_alive(id))
	{
		info_print(id,"Your adrenaline full!")
		if (!get_pcvar_num(g_cvar_ut_style))
			menu_display(id, g_Menu, 0)
		else
		{
			info_print(id,"Use Combo to turn on Adrenaline!")
			info_print(id,"WWSS - GodMode")
			info_print(id,"SSSS - Regeneration, DDAA - Invisible")
		}
		
		show_adrenaline(32+id)
		#if defined SOUND_ON
		if (get_pcvar_num(g_cvarSound))
			client_cmd(id, "spk %s",SOUND_ADRENALINE)
		#endif
	}
	return PLUGIN_HANDLED
}

public cmd_adrenaline(id, level, cid)
{
	if (!cmd_access(id, level, cid, 2))
		return PLUGIN_HANDLED

	new Arg1[24]
	read_argv(1, Arg1, 23)
	
	if (Arg1[0] == '@')
	{
		new Team = 0
          
		if (equali(Arg1[1], "CT"))
		{
			Team = 2
		}
		else 
		if (equali(Arg1[1], "T"))
		{
			Team = 1
		}
		
		new players[32], num
		
		get_players(players, num)
		new i
		for (i=0; i<num; i++)
		{
			if (!Team)
			{
				give_adrenaline(players[i])
			}
			else
			{
				if (get_user_team(players[i]) == Team)
				{
						give_adrenaline(players[i])
				}
			}
		}
	}
	else
	{
		new player = cmd_target(id, Arg1, 0)
		if (!player)
		{
			console_print(id, "Target %s is not valid!", Arg1)
			return PLUGIN_HANDLED
		}
		else
		{
			give_adrenaline(player)
		}
	}
	
	return PLUGIN_HANDLED	
}
	
	
	
	
public give_adrenaline(id)
{		
	remove_task(id)
	g_AdrenalineIsOn[id]=false
	
	if (g_GodMode[id])
	{
		fm_set_user_godmode(id)
	}
	g_Inv[id]=false
	g_GodMode[id]=false
	g_adrenaline[id]=100
	
	if (is_user_alive(id))
	{
		if (!get_pcvar_num(g_cvar_ut_style))
			menu_display(id, g_Menu, 0)
		else
		{
			info_print(id,"Use Combo to turn on Adrenaline!")
			info_print(id,"WWSS - GodMode")
			info_print(id,"SSSS - Regeneration, DDAA - Invisible")
		}
		show_adrenaline(32+id)
		#if defined SOUND_ON
		if (get_pcvar_num(g_cvarSound))
			client_cmd(id, "spk %s",SOUND_ADRENALINE)
		#endif
	}
	else
		info_print(id,"Your is dead now")
		
	return PLUGIN_HANDLED

}



public client_disconnect(id)
{
	remove_task(id)
	g_adrenaline[id]=0
	g_Inv[id]=false
	g_AdrenalineIsOn[id]=false
	g_GodMode[id]=false
}

public info_print(id,str[])
{
	new text[100]
	format(text,99,"^x04[ADRENALINE] ^x01%s",str)
	message_begin(MSG_ONE, get_user_msgid("SayText"), {0,0,0}, id)
	write_byte(id)
	write_string(text)
	message_end()
    
	return PLUGIN_HANDLED
	
}

public resetHud(id)
{
	remove_task(id)
	g_AdrenalineIsOn[id]=false
	
	if (g_GodMode[id])
	{
		fm_set_user_godmode(id)
	}
	g_Inv[id]=false
	g_GodMode[id]=false
	show_adrenaline(32+id)
}
